cooldown_timer = 30
--[[todo:
make cannon animation
better textures
sound
math.atan to make it come out of the barrel
]]--
CANNON_ENTITY = { 
	physical = true, 
	collisionbox = {-1.0,-1.0,-1.0, 1.0,1.0,1.0}, 
	visual = "mesh", 
	mesh = "cannon.x", 
	textures = {"cannon.png"},
	operator = nil,
	cooldown = 0,
	move_sound = false,
}
CANNON_ENTITY.get_staticdata = function(self)
	return minetest.serialize({
		operator = self.operator,
	})
end

CANNON_ENTITY.on_activate = function(self, staticdata)
	if string.sub(staticdata, 1, string.len("return")) == "return" then
		local data = minetest.deserialize(staticdata)
		if data and type(data) == "table" then
			self.operator = data.operator
		end
	end
end

CANNON_ENTITY.on_activate= function(self, staticdata)
	--self.object:set_animation({x=0,y=40}, 30, 0)
	self.object:setacceleration({x=0,y=-10,z=0})
	self.object:setvelocity({x=0,y=0,z=0})
	minetest.sound_play("cannon_running", {
	object = self.object,
	gain = 1.0, -- default
	max_hear_distance = 200, -- default
	loop = true, -- only sounds connected to objects can be looped
	})
end

CANNON_ENTITY.on_rightclick = function(self,clicker)
	--this is lifted from pilzadam carts because I am lazy
	if not clicker or not clicker:is_player() then
		return
	end
	if self.operator and clicker == self.operator then
		--self.operator = nil
		clicker:set_detach()
	elseif not self.operator then
		self.operator = clicker
		clicker:set_attach(self.object, "", {x=0,y=0,z=0}, {x=0,y=0,z=0})
		self.cooldown = 0
	end
end

CANNON_ENTITY.on_step = function(self)
	if self.cooldown < cooldown_timer then
		self.cooldown = self.cooldown + 1
	end
	if self.operator ~= nil then
		if not self.operator:is_player() then
				self.operator = nil
			return
		end
		local movesound_test = self.object:getyaw()
		self.object:setyaw(self.operator:get_look_yaw())
		if self.object:getyaw() ~= movesound_test and self.move_sound == false then
			minetest.sound_play("cannon_move", {
			object = self.object,
			gain = 1.0, -- default
			max_hear_distance = 200, -- default
			loop = false, -- only sounds connected to objects can be looped
			})
			self.move_sound = true
		else
			self.move_sound = false
		end
		if self.operator:get_player_control().RMB == true and self.cooldown == cooldown_timer then
			if self.operator:get_wielded_item():to_table() ~= nil then
				if self.operator:get_wielded_item():to_table().name == "default:stone" then
					local obj = minetest.env:add_entity(self.object:getpos(), "cannon:cannonball")
					obj:setvelocity({x= math.sin(self.object:getyaw()-1.57)*-40, y = 18, z = math.cos(self.object:getyaw()-1.57)*40})
					obj:setacceleration({x = 0, y = -10, z =0})
					minetest.sound_play("cannon", {
					pos=self.object:getpos(),
					})
					self.cooldown = 0
				end
			end
		end
	end
end
minetest.register_entity("cannon:cannon", CANNON_ENTITY)


CANNONBALL_ENTITY = { 
	physical = true, 
	collisionbox = {-0.2,-0.2,-0.2, 0.2,0.2,0.2}, 
	visual = "cube",
	textures = {"default_stone.png","default_stone.png","default_stone.png","default_stone.png","default_stone.png","default_stone.png"},
	visual_size = {x=0.2, y=0.2},
}
CANNONBALL_ENTITY.on_step = function(self)
	local speed = self.object:getvelocity()
	if speed.y == 0 then
		minetest.sound_play("tnt_explode", {
			pos = self.object:getpos(),
			gain = 1.0,
			max_hear_distance = 200,
		})
		local objects = minetest.env:get_objects_inside_radius(self.object:getpos(), 7)
		for _,obj in ipairs(objects) do
			if obj:is_player() or (obj:get_luaentity() and obj:get_luaentity().name ~= "__builtin:item") then
				local obj_p = obj:getpos()
				local vec = {x=obj_p.x, y=obj_p.y, z=obj_p.z}
				local dist = (vec.x^2+vec.y^2+vec.z^2)^0.5
				local damage = (80*0.5^dist)*2
				obj:punch(obj, 1.0, {
					full_punch_interval=1.0,
					groupcaps={
						fleshy={times={[1]=1/damage, [2]=1/damage, [3]=1/damage}},
						snappy={times={[1]=1/damage, [2]=1/damage, [3]=1/damage}},
					}
				}, nil)
			end
		end
		for x=-6,6 do
			for y=-6,6 do
				for z=-6,6 do
					if x*x+y*y+z*z <= 6 * 6 + 6 then
						local np={x=self.object:getpos().x+x,y=self.object:getpos().y+y,z=self.object:getpos().z+z}
						local n = minetest.env:get_node(np)
						if n.name ~= "air" then
							minetest.env:remove_node(np)
						end
					end
				end
			end
		end
		self.object:remove()
	end
end
minetest.register_entity("cannon:cannonball", CANNONBALL_ENTITY)